Table table;
int rowNums;
ArrayList<dataList> dataPoints = new ArrayList<dataList>();

float TopRadius = 0;
float BottomRadius = 180;
float Tall = 200;
int Sides = 20;

float[] xArray = new float[8423];
float[] yArray = new float[8423];
float[] zArray = new float[8423];

PImage artistPics;

int counter = 0;

import peasy.*;
PeasyCam cam; 

void setup() {
  size(1600, 900, P3D);
  float fov = PI/5; // default PI/3
  float aspect = float(width)/float(height);
  float zNear = 1;
  float zFar = 20000;
  perspective(fov, aspect, zNear, zFar);
  cam = new PeasyCam(this, 100);
  table = loadTable("radioheaddata.csv", "header");
  rowNums = table.getRowCount();

  for (int i = 0; i<rowNums; i++) {
    int followers = table.getInt(i, 0);
    String genreA = table.getString(i, 1);
    String genreB = table.getString(i, 2);
    String genreC = table.getString(i, 3);
    String id = table.getString(i, 4);
    String imgURL = table.getString(i, 5);
    String link = table.getString(i, 6);
    String name = table.getString(i, 7);
    int popularity = table.getInt(i, 8);
    int imgH = table.getInt(i,9);
    int imgW = table.getInt(i,10);
    dataPoints.add(new dataList(followers, genreA, genreB, genreC, id, imgURL, link, name, popularity, imgH, imgW));
  }
}

void draw() {

  background(0);
  stroke(255, 255, 255, 20);
  strokeWeight(1);

  for (int i=0; i<421; i++) {
    //Drawing the Lines
    drawCone(xArray[i], yArray[i], zArray[i], TopRadius, BottomRadius+i*3, Tall, Sides);
  }

  //Drawing the points
  for (int i=0; i<8421; i++) {
    stroke(255, 255, 255, (log(dataPoints.get(i).followers)*13));
    strokeWeight((dataPoints.get(i).popularity)/7);
    point(xArray[i], yArray[i], zArray[i]);
    float mouseObjectDistance = sq(mouseX-screenX(xArray[i], yArray[i], zArray[i]))+sq(mouseY-screenY(xArray[i], yArray[i], zArray[i])); 
    if (mouseObjectDistance < 50) {
      fill(255);
      textMode(SHAPE);
      textSize(5);
      text(dataPoints.get(i).name.toUpperCase(), xArray[i], yArray[i]-3, zArray[i]);
      textSize(2);
      fill(255, 255, 255, 85);
      text(dataPoints.get(i).genreA.toUpperCase() + "," + dataPoints.get(i).genreC.toUpperCase(), xArray[i], yArray[i], zArray[i]);
      text("FOLLOWER COUNT:" + dataPoints.get(i).followers, xArray[i], yArray[i]+2, zArray[i]);
      artistPics = loadImage(dataPoints.get(i).imgURL, "jpg");
      beginShape();
      noStroke();
      texture(artistPics);
      //Start top right, go clockwise
      vertex(xArray[i]+25, yArray[i]+23, zArray[i], dataPoints.get(i).imgW, dataPoints.get(i).imgH);
      vertex(xArray[i]+25, yArray[i]+3, zArray[i], dataPoints.get(i).imgW, 0);
      vertex(xArray[i]+5, yArray[i]+3, zArray[i], 0, 0);
      vertex(xArray[i]+5, yArray[i]+23, zArray[i], 0, dataPoints.get(i).imgH);
      endShape();
    }
  }

  //image(artistPics[0], xArray[i], yArray[i]+4, 40, 40);

  fill(255);
  textSize(100);
  text("THE ARTIST NETWORK", -560, -200, -2500);
  textSize(75);
  text("CHARTING RELATED ARTISTS ON SPOTIFY", -780, 200, -2500);
}

void drawCone(float x, float y, float z, float topRadius, float bottomRadius, float tall, int sides) {
  float angle = 0;
  float angleIncrement = TWO_PI / sides;
  beginShape(QUADS);
  for (int i = 0; i < sides + 1; i++) {

    vertex(x + topRadius*cos(angle), y + 0, z + topRadius*sin(angle));
    vertex(x + bottomRadius*cos(angle), y + tall, z + bottomRadius*sin(angle));

    xArray[i + (Sides*counter) + 1] = x + bottomRadius*cos(angle);
    yArray[i + (Sides*counter) + 1] = y + tall;
    zArray[i + (Sides*counter) + 1] = z + bottomRadius*sin(angle);

    angle += angleIncrement;
  }
  endShape();
  if (counter<420) {
    counter++;
  }
}